#include "GetSAM.h"



void Convert2Hex(BYTE *Input, DWORD InputLen, BYTE *output){
DWORD i;
char *strHash;
char *hex = "0123456789abcdef";

	for(i = 0; i < InputLen; i++){
			output[i*2]     = hex[Input[i] >> 4];
			output[(i*2)+1] = hex[Input[i] & 0xF];
		}
return;
}

void RC4Crypt(BYTE* rc4_key, BYTE* ClearText, BYTE *EncryptBuffer){

KEY_BLOB DesKeyBlob;
BYTE bDesKeyBlob[28];

DWORD dwError, i, dwWorkingBufferLength, dwOriginalPlainTextLength, dwEncryptedCypherLength;

char buffer[MAX_PATH];
LPTSTR lpbuf = buffer;

HCRYPTPROV hCryptProv = (ULONG_PTR)NULL; 
HCRYPTKEY hKey = (ULONG_PTR)NULL;

	if(hCryptProv)CryptReleaseContext(hCryptProv, 0);

	if(!CryptAcquireContext(&hCryptProv, NULL, NULL, PROV_RSA_FULL, CRYPT_VERIFYCONTEXT)){
		dwError = GetLastError();
		wsprintf(lpbuf, "%x", dwError);
		Write2LogFile("Error Acquiring RC4 Context:", 0);
		Write2LogFile(lpbuf, 0);
		return;
	}

	ZeroMemory(&DesKeyBlob, sizeof(DesKeyBlob));

	DesKeyBlob.dwDefault = 0x0208;
	DesKeyBlob.dwAlgID = CALG_RC4;
	DesKeyBlob.dwKeyLen = 0x10;
	for (i = 0; i < 16; i++){
		DesKeyBlob.Key[i] = rc4_key[i];
	}

	memcpy(bDesKeyBlob, (PVOID)&DesKeyBlob, 28);

	if (!CryptImportKey(hCryptProv, bDesKeyBlob, sizeof(DesKeyBlob), 0, CRYPT_EXPORTABLE, &hKey)){
		dwError = GetLastError();
		wsprintf(lpbuf, "%x", dwError);
		Write2LogFile("Error importing key:", 0);
		Write2LogFile(lpbuf, 0);
		goto CleanAndReturn;
	}

	dwWorkingBufferLength = 16;
	dwOriginalPlainTextLength = dwWorkingBufferLength;

	if (!CryptEncrypt(hKey, (HCRYPTHASH)NULL, TRUE, 0, (BYTE *)NULL, &dwWorkingBufferLength, 16)){
		dwError = GetLastError();
		wsprintf(lpbuf, "%x", dwError);
		Write2LogFile("Error during encryption", 0);
		Write2LogFile(lpbuf, 0);
		goto CleanAndReturn;
	}

	dwEncryptedCypherLength = dwWorkingBufferLength;

	for (i = 0; i <= dwWorkingBufferLength; i++){
		EncryptBuffer[i] = ClearText[i];
	}

	dwWorkingBufferLength = dwOriginalPlainTextLength;

	if (!CryptEncrypt(hKey, (HCRYPTHASH)NULL, TRUE, 0, EncryptBuffer, &dwWorkingBufferLength, 
			dwEncryptedCypherLength)){
		dwError = GetLastError();
		wsprintf(lpbuf, "%x", dwError);
		Write2LogFile("Error during encryption", 0);
		Write2LogFile(lpbuf, 0);
		goto CleanAndReturn;
	}

	if (hKey)
		if (!CryptDestroyKey(hKey))Write2LogFile("Error Releasing Key", 0);

	//CryptAcquireContext(&hCryptProv, "CryptoRC4", NULL, PROV_DH_SCHANNEL, CRYPT_DELETEKEYSET);
	if(hCryptProv)
		if (!CryptReleaseContext(hCryptProv, 0))Write2LogFile("Error Releasing Context", 0);

	return;


CleanAndReturn:

	if (hKey)
		if (!CryptDestroyKey(hKey))Write2LogFile("Error Releasing Key", 0);

	if(hCryptProv)
		if (!CryptReleaseContext(hCryptProv, 0))Write2LogFile("Error Releasing RC4 Context", 0);

return;
}