//Security level for SSPI
#define SECURITY_WIN32

#include <windows.h>
#include <wincrypt.h>

#define REGISTRY_KEY "SAM\\SAM\\Domains\\Account\\Users"

#define REGISTRY_KEY_ACCOUNT "SAM\\SAM\\Domains\\Account"
#define REGISTRY_LSAJD "SYSTEM\\CurrentControlSet\\Control\\Lsa\\JD"
#define REGISTRY_LSASKEW "SYSTEM\\CurrentControlSet\\Control\\Lsa\\Skew1"
#define REGISTRY_LSAGBG "SYSTEM\\CurrentControlSet\\Control\\Lsa\\GBG"
#define REGISTRY_LSADATA "SYSTEM\\CurrentControlSet\\Control\\Lsa\\Data"

#define MAX_DATA_SIZE 8192
typedef unsigned char DES_cblock[8];

void main(int, TCHAR *argv[]);

void GetSAMServiceMain(DWORD, LPTSTR*);
DWORD WINAPI HandlerFunction(DWORD, DWORD, LPVOID, LPVOID);
void Write2LogFile(LPVOID, DWORD);
void EnumerateRegValues(HKEY, LPTSTR, PBYTE, LPDWORD);
void EnumerateRegData(HKEY, LPTSTR, PBYTE, LPDWORD);
int RegistryEnumerateSAM(void);
void RetrieveSysKey(LPTSTR, BYTE *);
void DumpSam(char *);
void RC4Crypt(BYTE*, BYTE*, BYTE *);
void Convert2Hex(BYTE *, DWORD, BYTE *);

void str_to_key(unsigned char *,unsigned char *);
void sid_to_key1(unsigned long,unsigned char[8]);
void sid_to_key2(unsigned long,unsigned char[8]);
void des_set_odd_parity(DES_cblock *);

typedef struct {
	DWORD dwDefault;
	DWORD dwAlgID;
	DWORD dwKeyLen;
	BYTE Key[16];
}KEY_BLOB;

typedef struct {
	BLOBHEADER BlobHeader;
	DWORD dwKeyLen;
	BYTE Key[8];
}DESKEY_BLOB;