/*****************************************************************************************************

	Coded Februar 2012 -- by -- Vincent Roch

*****************************************************************************************************/

#include "GetSAM.h"

SERVICE_STATUS_HANDLE hServiceStatus;

//Log file path is defined globally as we access it from the whole code.
char cCurrentDirectory[256];
LPTSTR lpCurrentDirectory = cCurrentDirectory;

int APIENTRY WinMain(HINSTANCE hProg, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow){

	SERVICE_TABLE_ENTRY DispatchTable[] = 
    { 
        {"GetSAM", (LPSERVICE_MAIN_FUNCTION)&GetSAMServiceMain}, 
        {NULL, NULL} 
    };

    StartServiceCtrlDispatcher(DispatchTable);

}
DWORD WINAPI HandlerFunction(DWORD dwControl, DWORD dwEventType, LPVOID lpEventData, LPVOID lpContext){
SERVICE_STATUS ServiceStatus;

	if (dwControl == SERVICE_CONTROL_PRESHUTDOWN || 
		dwControl == SERVICE_CONTROL_SHUTDOWN || 
		dwControl == SERVICE_CONTROL_STOP){
			ServiceStatus.dwServiceType = SERVICE_WIN32_OWN_PROCESS;
			ServiceStatus.dwCurrentState = SERVICE_STOPPED;
			SetServiceStatus(hServiceStatus, &ServiceStatus);
	}


return(0);
}

void GetSAMServiceMain(DWORD dwArgc, LPTSTR* lpszArgv){
SERVICE_STATUS ServiceStatus;

	//Retrieve the log file path from the command line
	if (dwArgc == 2){
		lstrcpy(lpCurrentDirectory, lpszArgv[1]);
	}


	hServiceStatus = RegisterServiceCtrlHandlerEx("GetSAM", (LPHANDLER_FUNCTION_EX)&HandlerFunction, NULL);
	if (!hServiceStatus)Write2LogFile("Error Registering service", 0);

	ZeroMemory(&ServiceStatus, sizeof(SERVICE_STATUS));
	ServiceStatus.dwServiceType = SERVICE_WIN32_OWN_PROCESS;
	ServiceStatus.dwCurrentState = SERVICE_RUNNING;
	ServiceStatus.dwControlsAccepted = SERVICE_ACCEPT_PRESHUTDOWN | SERVICE_ACCEPT_SHUTDOWN | 
		SERVICE_ACCEPT_STOP;

	SetServiceStatus(hServiceStatus, &ServiceStatus);

	//Call the real dump function
	RegistryEnumerateSAM();

}



void Write2LogFile(LPVOID lp2write, DWORD dwLen){
			DWORD nbWritten;
			HANDLE hTextFile;

			if (!dwLen)dwLen = lstrlen(lp2write);
			if (!dwLen)return;
		
			hTextFile = CreateFile(lpCurrentDirectory,GENERIC_WRITE,FILE_SHARE_READ 
				| FILE_SHARE_WRITE,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
			SetFilePointer(hTextFile,0,NULL,FILE_END);
			WriteFile(hTextFile, lp2write, dwLen, &nbWritten,NULL);
			WriteFile(hTextFile, "\r\n", lstrlen("\r\n"), &nbWritten,NULL);
			CloseHandle(hTextFile);
			return;
}
